#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>

static size_t write_data(void *ptr, size_t size, size_t nmemb, void *stream) {
	int written = fwrite(ptr, size, nmemb, (FILE *)stream);
	return written;
}

int main(int argc, char **argv) {
	CURL *curl_handle;
	static const char *bodyfilename = "servers.temp.xml";
	FILE *bodyfile;
	
	curl_global_init(CURL_GLOBAL_ALL);
	curl_handle = curl_easy_init();
	curl_easy_setopt(curl_handle, CURLOPT_URL, "http://www.quakeservers.net/european_servers.php");
	curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, 1);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, write_data);

	bodyfile = fopen(bodyfilename,"w");
	if (bodyfile == NULL) {
		curl_easy_cleanup(curl_handle);
		return -1;
	}

	curl_easy_setopt(curl_handle,   CURLOPT_WRITEDATA, bodyfile);
	curl_easy_perform(curl_handle);

	fclose(bodyfile);
	curl_easy_cleanup(curl_handle);
	
	if ((rename("servers.temp.xml", "servers.xml")) < 0) printf("Error: cannot save the filelist, skipping\n");

	struct tm *mytime;
	time_t lt;

	while (1) {
		lt = time(NULL);
		mytime = localtime(&lt);
		if (mytime->tm_min == 0 || mytime->tm_min == 29) {
			printf("success\n");
			break;
		}
	}

	return 0;

}

