package require udp 1.0.6

bind pub -|- "!qw" pub:qstat
bind pub -|- "!help" pub:qstat_help

set skarpeta [udp_open]
fconfigure $skarpeta -buffering none -blocking 0 -remote [list localhost 23427]

proc UDPEvent {skara kanal} {
  set reply [read $skara]
  foreach line [split $reply \n] {
    putquick "PRIVMSG $kanal :$line"
  }
}

proc pub:qstat_help {nick host hand chan arg} {
  putserv "NOTICE $nick :Please check http://kf.quakeworld.pl"
  return 0
}

proc pub:qstat {nick host hand chan arg} {
  global skarpeta reply

  # SEND VIA UDP
  puts -nonewline $skarpeta $arg
  flush $skarpeta

  # REPLY
  fileevent $skarpeta readable [list UDPEvent $skarpeta $chan]
  flush $skarpeta

  return 0
}

# check for valid chars
proc qstat:input_check {text} {
  if {[regexp \[^\[:alnum:\]_\.\:\] $text]} { return 1 }
  if {[string match "0*" $text]} { return 1 }
  return 0
}

putlog "Krulowa Fal Quakeworld server querying machine v 2.0"
