#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>

void error(char *);
int main(int argc, char *argv[])
{
   int sock, length, n;
   struct sockaddr_in server, from;
   struct hostent *hp;
   char buffer[1024];
   
   if (argc != 3) { printf("Usage: server port\n");
                    exit(1);
   }
   sock= socket(AF_INET, SOCK_DGRAM, 0);
   if (sock < 0) error("socket");

   server.sin_family = AF_INET;
   hp = gethostbyname(argv[1]);
   if (hp==0) error("Unknown host");

   bcopy((char *)hp->h_addr, 
        (char *)&server.sin_addr,
         hp->h_length);
   server.sin_port = htons(atoi(argv[2]));
   length=sizeof(struct sockaddr_in);
   strcpy(buffer,"quake.aster.pl:27600");
   strcat(buffer,"\0");
   printf("%s\n",buffer);
   n=sendto(sock,buffer,strlen(buffer),0,&server,length);
   if (n < 0) error("Sendto");
   memset(buffer,0,1024);
   n = recvfrom(sock,buffer,1024,0,&from, &length);
   if (n < 0) error("recvfrom");
   printf("%s\n",buffer);
}

void error(char *msg)
{
    perror(msg);
    exit(0);
}

